globals 
[ 
  Amean ;; 
  Bmean ;;
  Acnt ;;
  Bcnt ;;
  SampleIndex
  Samplewho
  DiffMeans 
  DiffMeansO
  Trials
  TORME
  Proportion
  SimStopper
  ListOfMeans 
  IsInitialized
  IsSetup
  ChipsList
  TotalChips
  dataA
  dataB
]

breed [circles circle]
breed [banners banner]

circles-own
[
  value ;; number from list
  group ;; either A=true or B=false
]

to LoadEpidemic1
  Initialize
  ask circle 0 [ set value 358 ]
  ask circle 1 [ set value 331 ]
  ask circle 2 [ set value 351 ]
  ask circle 3 [ set value 371 ]
  ask circle 4 [ set value 341 ]
  ask circle 5 [ set value 358 ]
  ask circle 6 [ set value 348 ]
  ask circle 7 [ set value 321 ]
  ask circle 8 [ set value 351 ]
  ask circle 9 [ set value 344 ]
  ask circle 12 [ set value 324 ]
  ask circle 13 [ set value 314 ]
  ask circle 14 [ set value 311 ]
  ask circle 15 [ set value 321 ]
  ask circle 16 [ set value 334 ]
  ask circle 17 [ set value 318 ]
  ask circle 18 [ set value 307 ]
  ask circle 19 [ set value 348 ]
  ask circle 20 [ set value 341 ]
  ask circle 21 [ set value 348 ]
  SetUp
end 

to LoadEpidemic2
  Initialize
  ask circle 0 [ set value 358 ]
  ask circle 1 [ set value 331 ]
  ask circle 2 [ set value 351 ]
  ask circle 3 [ set value 371 ]
  ask circle 4 [ set value 341 ]
  ask circle 5 [ set value 358 ]
  ask circle 6 [ set value 348 ]
  ask circle 7 [ set value 371 ]
  ask circle 8 [ set value 351 ]
  ask circle 9 [ set value 344 ]
  ask circle 12 [ set value 344 ]
  ask circle 13 [ set value 344 ]
  ask circle 14 [ set value 351 ]
  ask circle 15 [ set value 341 ]
  ask circle 16 [ set value 354 ]
  ask circle 17 [ set value 358 ]
  ask circle 18 [ set value 338 ]
  ask circle 19 [ set value 338 ]
  ask circle 20 [ set value 351 ]
  ask circle 21 [ set value 348 ]
  SetUp
end

to attach-banner [x]  ;; assign value to chip
  hatch-banners 1 [
    set color green
    set label-color black
    set size 0
    set label x
    create-link-from myself [
      tie
      hide-link
    ]
    
  ]
end

to change-banner [x] ;; change value of chip
  ask out-link-neighbors [ set label x ]
end

to reposition  ;; banner procedure
  move-to one-of in-link-neighbors
  set heading 150
  fd 1
end

to Initialize 
  ;; (for this model to work with NetLogo's new plotting features,
  ;; __clear-all-and-reset-ticks should be replaced with clear-all at
  ;; the beginning of your setup procedure and reset-ticks at the end
  ;; of the procedure.)
  __clear-all-and-reset-ticks
  set Trials 0
  set SimStopper SimNum 
  set-default-shape circles "circle"
  create-circles 24
    [  set size 3.75
       attach-banner "" ]

  ask circles 
    [ set value 1E10
      ifelse ( who < 12 ) 
        [ set group true 
          set color red + 2
          ifelse ( who < 6 )
            [  setxy -12 ( 12 - 4 * who ) ]
            [  setxy -4  ( 12 - 4 * ( who - 6 ) ) ]

        ]
        [ set group false 
          set color yellow + 2 
          ifelse ( who < 18 )
            [  setxy  4 ( 12 - 4 * ( who - 12 ) ) ]
            [  setxy 12 ( 12 - 4 * ( who - 18 ) ) ]
        ]
    ]    
  ask patches 
    [
      if( ( pxcor < 0 or pxcor > 0) and ( pycor > -11 or pycor < -11 ) )
        [ set pcolor white ]
    ]
  set IsInitialized true
  set IsSetup false  
end

to startup
   Initialize
end 

to SetUp
  set Amean 0 ;
  set Bmean 0 ;
  set Acnt 0;
  set Bcnt 0;
  set ChipsList [] ;
  set TotalChips 0 ;
  
  ask circles 
    [ ifelse ( value < 1E10 )
        [ change-banner value 
          set ChipsList lput who ChipsList ; 
          set TotalChips ( TotalChips + 1 ) ; 
          
          ifelse ( who < 12 )
            [ 
              set Amean Amean + value 
              set Acnt Acnt + 1
              set color red + 2 
              ifelse ( who < 6 )
                [  setxy -12 ( 12 - 4 * who ) ]
                [  setxy -4  ( 12 - 4 * (who - 6) ) ]
            ]
            [ 
              set Bmean Bmean + value
              set Bcnt Bcnt + 1  
              set color yellow + 2 
              ifelse ( who < 18 )
                [  setxy  4 ( 12 - 4 * ( who - 12 ) ) ]
                [  setxy 12 ( 12 - 4 * ( who - 18 ) ) ]
            ]
            
        ]
        [ ht ]
    ]
  if ( Acnt != 0 and Bcnt != 0 )  
    [
      ask patch -6 -13 
        [ 
          set plabel-color black 
          set plabel word "Mean = " ( Amean / Acnt ) 
        ]
      ask patch 10 -13 
        [ 
          set plabel-color black 
          set plabel word "Mean = " ( Bmean / Bcnt )
        ]
   
      set DiffMeansO precision ( Amean / Acnt - Bmean / Bcnt ) 5
      set DiffMeans DiffMeansO
   
      set ListOfMeans ( list DiffMeans )
   
      set-current-plot "Difference in Means Histogram"
      set-plot-x-range precision ( -1.2 * abs(DiffMeans) ) 5  precision ( 1.2 * abs(DiffMeans) ) 5 
      set-current-plot-pen "typicals" 
      set-plot-pen-interval abs(DiffMeans) / 25
      set-current-plot-pen "extremes"
      set-plot-pen-interval abs(DiffMeans) / 25 
      plotxy DiffMeans 1
      set TORME 1
      set Proportion TORME ;
   ]
   set IsSetup true;
end



to LoadData
  Initialize
  set dataA read-from-string ( word ( word "[" Adata ) "]" ) 
  set dataB read-from-string ( word ( word "[" Bdata ) "]" ) 
  if( (length dataA )  > 10 ) 
     [ user-message( "Only the first 12 values of each will be used" ) ]
  ifelse ( ( empty? dataA) or (empty? dataB) ) 
     [ user-message ( "Both Adata and Bdata must contain numbers separated by spaces." ) ]
     [ ask circles 
        [ ifelse( who < 12 )
            [ if ( who < length dataA )
               [ if ( is-number? ( item who dataA ) )
                  [ set value item who dataA 
                    set label value
                  ] 
               ]
            ]
            [ if ( ( who - 12 ) < length dataB )
               [ if ( is-number? ( item ( who - 12 ) dataB ) )
                  [ set value item ( who - 12 ) dataB 
                    set label value
                  ] 
               ]
            ]  
        ]
     ]
  Go 
end

to Go
   ifelse ( IsSetup )
     [ gonow ]
     [ Setup
       set IsSetup true 
       set IsInitialized false
     ]
end

to gonow
  set Amean 0 ;
  set Bmean 0 ;
  set Acnt 0;
  set Bcnt 0;

  set SampleIndex shuffle ChipsList
  set Samplewho 0  
  set Trials Trials + 1 
  
  foreach SampleIndex 
    [
      ask circle ?1 
        [  
          ifelse ( value < 1E10 )
            [
              change-banner value
              ifelse ( Samplewho < ( TotalChips / 2 ) )
                [ 
                  set Amean Amean + value 
                  set Acnt Acnt + 1
                  ifelse ( Samplewho < ( TotalChips / 4 ) )
                    [  setxy -12 ( 12 - 4 * Samplewho ) ]
                    [  setxy -4  ( 12 - 4 * (Samplewho - floor( TotalChips / 4 ) ) ) ]
                ]
                [ 
                  set Bmean Bmean + value 
                  set Bcnt Bcnt + 1 
                  ifelse ( Samplewho < ( 3 * TotalChips / 4 ) )
                    [  setxy  4 ( 12 - 4 * ( Samplewho - floor ( TotalChips / 2 ) ) ) ]
                    [  setxy 12 ( 12 - 4 * ( Samplewho - floor ( 3 * TotalChips / 4 ) ) ) ]
                ]
             ]
             [ ht ]
        ]
        set Samplewho Samplewho + 1
    ]
  ask banners [reposition]
  ask patch -6 -13 
    [ 
      set plabel-color black 
      set plabel word "Mean = " precision ( Amean / Acnt ) 5 
    ]
  ask patch 10 -13 
    [ 
      set plabel-color black 
      set plabel word "Mean = " precision ( Bmean / Bcnt ) 5
    ]
  set DiffMeans precision ( Amean / Acnt - Bmean / Bcnt ) 5
  
  ifelse( DiffMeans >= abs(DiffMeansO) or  DiffMeans <= -1 * abs(DiffMeansO) ) 
    [ 
      set TORME TORME + 1 
      set ListOfmeans fput DiffMeans ListOfMeans
    ]
    [ set ListOfMeans lput DiffMeans ListOfMeans ]
   
  set-current-plot "Difference in Means Histogram"
  if( plot-x-max <= abs(DiffMeans) )
   [ 
     set-plot-x-range precision ( -1.2 * abs(DiffMeans) ) 5  precision ( 1.2 * abs(DiffMeans) ) 5  
   ]
  set-current-plot-pen "typicals" 
  histogram sublist ListOfMeans TORME length ( ListOfMeans ) 
  set-current-plot-pen "extremes"
  histogram sublist ListOfMeans 0  TORME    
  
  set Proportion precision ( TORME / Trials ) 5 
end

to Simulate
  Go 
  if( Trials >= SimStopper )
    [ 
      set SimStopper SimStopper + SimNum 
      stop 
    ]
end

@#$#@#$#@
GRAPHICS-WINDOW
135
10
640
476
16
14
15.0
1
11
1
1
1
0
1
1
1
-16
16
-14
14
0
0
1
ticks
30.0

BUTTON
5
10
60
43
NIL
Go
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
63
10
133
43
NIL
Simulate
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
385
480
640
680
Difference in Means Histogram
NIL
NIL
-100.0
100.0
0.0
10.0
true
false
"" ""
PENS
"typicals" 1.0 1 -13345367 true "" ""
"extremes" 1.0 1 -2674135 true "" ""

MONITOR
5
150
125
195
Current Diff in Means
DiffMeans
17
1
11

MONITOR
5
100
125
145
Original Diff in Means
DiffMeansO
17
1
11

MONITOR
5
210
65
267
NIL
Trials
17
1
14

TEXTBOX
420
690
610
710
Subintervals of possible means.\n
14
0.0
1

BUTTON
23
587
119
620
Significant
LoadEpidemic1
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
23
627
120
660
InSignificant
LoadEpidemic2
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

MONITOR
15
275
110
332
Proportion
Proportion
17
1
14

MONITOR
64
210
124
267
Count
TORME
17
1
14

SLIDER
5
50
130
83
SimNum
SimNum
100
1000
500
100
1
NIL
HORIZONTAL

TEXTBOX
11
340
136
482
Proportion is the percentage of differences in trial means whose magnitude exceeds that of the original difference in means.
14
0.0
1

INPUTBOX
160
535
377
595
Adata
1  2  3   4   5   6   7 
1
0
String

INPUTBOX
160
605
377
665
Bdata
8  9 10 11 12 13 14
1
0
String

BUTTON
290
675
377
708
Load Data
LoadData
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

TEXTBOX
200
485
380
536
Number of means that occur in a given subinterval.-->
14
0.0
1

TEXTBOX
50
675
280
705
Enter numbers separated by spaces into Adata and Bdata. Then press 'Load Data'.
12
0.0
1

TEXTBOX
10
480
180
596
Data in which the difference between the means of the data represented by the red and yellow chips are either significant or insignificant
14
0.0
1

@#$#@#$#@
## WHAT IS IT?

This section could give a general understanding of what the model is trying to show or explain.

## HOW IT WORKS

The first group of 10 numbers should be entered in A1 to A10, while the second group of 10 numbers should be entered in B1 to B10.  To use fewer than 10 numbers, enter 1E10 in any unutilized input.  

## HOW TO USE IT

This section could explain how to use the model, including a description of each of the items in the interface tab.

## THINGS TO NOTICE

This section could give some ideas of things for the user to notice while running the model.

## THINGS TO TRY

This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.

## EXTENDING THE MODEL

This section could give some ideas of things to add or change in the procedures tab to make the model more complicated, detailed, accurate, etc.

## NETLOGO FEATURES

This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.

## RELATED MODELS

This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.

## CREDITS AND REFERENCES

This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.3
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
1
@#$#@#$#@
